unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Types3D,
  FMX.Materials, FMX.Objects3D, FMX.Layers3D;

type
  TForm1 = class(TForm3D)
    Light1: TLight;
    Cone1: TCone;
    LightMaterialSource1: TLightMaterialSource;
    LightMaterialSource2: TLightMaterialSource;
    Timer1: TTimer;
    Grid3D1: TGrid3D;
    LightMaterialSource3: TLightMaterialSource;
    Path3D1: TPath3D;
    Camera1: TCamera;
    procedure Form3DShow(Sender: TObject);
    procedure Form3DKeyDown(Sender: TObject; var Key: Word; var KeyChar: Char;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure Form3DClose(Sender: TObject; var Action: TCloseAction);
  private
    { private 錾 }
    procedure BlockMove ;
    procedure BlockMake(n:integer) ;
    function BlockConflict : Boolean ;
  public
    { public 錾 }
    my_x,my_y,my_z : single ;
    dist : integer ;
    bl : array of TSphere ;
    dl : array of TDisk ;
    bn : integer ;
    EndFlag : Boolean ;
  end;

const
   _MIN_X = -5.0 ;
   _MIN_Y = -5.0 ;
   _MAX_X =  5.0 ;
   _MAX_Y =  5.0 ;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Form3DShow(Sender: TObject);
begin
   Camera1.Position.X := 10 ;
   Camera1.Position.Y := -10 ;
   Camera1.Position.Z := -10 ;
   Camera1.RotationAngle.Y := -45.0 ;
   Camera1.RotationAngle.X := -45.0 ;

   my_x := Cone1.Position.X ;
   my_y := Cone1.Position.Y ;
   my_z := Cone1.Position.Z ;
   dist := 0 ;
   Form1.Caption := 'F'+IntToStr(dist);

   bl := nil ;
   dl := nil ;
   bn := 0 ;
   EndFlag := False ;

   Timer1.Interval := 100 ;
   Timer1.Enabled := True ;
end;

procedure TForm1.Form3DClose(Sender: TObject; var Action: TCloseAction);
var
   i : integer ;
begin
   Timer1.Enabled := False ;

   for i := 0 to bn-1 do begin
      if (bl[i] <> nil) then
         bl[i].Free ;
      if (dl[i] <> nil) then
         dl[i].Free ;
   end;
   bl := nil ;
   dl := nil ;
end;

procedure TForm1.Form3DKeyDown(Sender: TObject; var Key: Word;
  var KeyChar: Char; Shift: TShiftState);
var
   mv : Integer ;
begin
   if (EndFlag) then exit ;

   mv := 0 ;
   Case(Key)of
   vkLEFT,  vkNUMPAD4:  mv := 4 ;
   vkRIGHT, vkNUMPAD6:  mv := 6 ;
   vkUP,    vkNUMPAD8:  mv := 8 ;
   vkDOWN,  vkNUMPAD2:  mv := 2 ;
   End;
   if (mv = 0) then begin
      Case(KeyChar)of
      '4':  mv := 4 ;
      '6':  mv := 6 ;
      '8':  mv := 8 ;
      '2':  mv := 2 ;
      end;
   end;
   //
   if (mv > 0) then begin
      Case(mv)of
         4: begin
               my_x := my_x - 0.5 ;
               if (my_x < _MIN_X) then
                  my_x := _MIN_X ;
            end;
         6: begin
               my_x := my_x + 0.5 ;
               if (my_x > _MAX_X) then
                  my_x := _MAX_X ;
            end;
         8: begin
               my_y := my_y - 0.5 ;
               if (my_y < _MIN_Y) then
                  my_y := _MIN_Y ;
            end;
         2: begin
               my_y := my_y + 0.5 ;
               if (my_y > _MAX_Y) then
                  my_y := _MAX_Y ;
            end;
      End;

      Cone1.Position.X := my_x ;
      Cone1.Position.Y := my_y ;
      Path3D1.Position.X := my_x ;
      // Camera1.Position.X := my_x ;
      // Camera1.Position.Y := my_y ;

      if not(BlockConflict) then begin
         EndFlag := True ;
         Timer1.Enabled := False ;
      end;

      Key := 0 ;
   end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Timer1.Enabled := False ;

   if (EndFlag) then exit ;

   Inc(dist) ;
   Form1.Caption := 'F'+IntToStr(dist);

   BlockMove ;    // Qړ

   if not(BlockConflict) then begin
      EndFlag := True ;
      exit ;
   end;

   if ((dist mod 10) = 0) then
      BlockMake(dist div 100) ;   // Q

   Timer1.Interval := 50 ;
   Timer1.Enabled := True ;
end;

// Q
procedure TForm1.BlockMake(n:integer) ;
var
   i,j : integer ;
   rx,ry : Single ;
begin
   bn := bn + n + 1;
   SetLength(bl, bn);
   SetLength(dl, bn);

   for i := 0 to n do begin
      j  := bn-n+i-1 ;
      rx := Random*10.0 - 5.0 ;
      ry := Random*10.0 - 5.0 ;
      bl[j] := nil ;
      try
         bl[j] := TSphere.Create(Self);
         bl[j].Visible := False ;
         bl[j].Name := 'Shpere' + IntToStr(j) ;
         bl[j].MaterialSource := LightMaterialSource2 ;
         bl[j].Parent := Form1 ;
         bl[j].Position.X := rx ;
         bl[j].Position.Y := ry ;
         bl[j].Position.Z := 5.0 ;
         bl[j].Width := 1 ;
         bl[j].Height:= 1 ;
         bl[j].Depth := 1 ;
         bl[j].Visible := True ;
      except
         ;
      end;

      dl[j] := nil ;
      try
         dl[j] := TDisk.Create(Self);
         dl[j].Visible := False ;
         dl[j].Name := 'Disk' + IntToStr(j) ;
         dl[j].MaterialSource := LightMaterialSource3 ;
         dl[j].Parent := Form1 ;
         dl[j].Position.X := rx ;
         dl[j].Position.Y := 5.0 ;
         dl[j].Position.Z := 5.0 ;
         dl[j].Width := 1 ;
         dl[j].Height:= 1 ;
         dl[j].Visible := True ;
      except
         ;
      end;
   end;
end;

// Qړ
procedure TForm1.BlockMove ;
var
   i : integer ;
begin
   for i := 0 to bn-1 do begin
      if (bl[i] <> nil) then begin
         bl[i].Position.Z := bl[i].Position.Z - 0.5 ;
         if (bl[i].Position.Z < -10.0) then begin
            bl[i].Free ;
            bl[i] := nil ;
         end;
      end;
      if (dl[i] <> nil) then begin
         dl[i].Position.Z := dl[i].Position.Z - 0.5 ;
         if (dl[i].Position.Z < -10.0) then begin
            dl[i].Free ;
            dl[i] := nil ;
         end;
      end;
   end;
end;

// QƂ̓蔻
//    ret : True : Z[t@False : 
function TForm1.BlockConflict : Boolean ;
var
   i : integer ;
   x1,x2,y1,y2,z1,z2 : single ;
begin
   Result := True ;
   x1 := my_x - Cone1.Width / 2.0 ;
   x2 := my_x + Cone1.Width / 2.0 ;
   y1 := my_y - Cone1.Depth / 2.0 ;
   y2 := my_y + Cone1.Depth / 2.0 ;
   z1 := my_z - Cone1.Height/ 2.0 ;
   z2 := my_z + Cone1.Height/ 2.0 ;

   for i := 0 to bn-1 do begin
      if (bl[i] <> nil) then begin
         if ((bl[i].Position.X + bl[i].Width /2.0) < x1) then continue ;
         if ((bl[i].Position.X - bl[i].Width /2.0) > x2) then continue ;
         if ((bl[i].Position.Y + bl[i].Height/2.0) < y1) then continue ;
         if ((bl[i].Position.Y - bl[i].Height/2.0) > y2) then continue ;
         if ((bl[i].Position.Z + bl[i].Depth /2.0) < z1) then continue ;
         if ((bl[i].Position.Z - bl[i].Depth /2.0) > z2) then continue ;
         Result := False ;
         break ;
      end;
   end;

   // 
   if not(Result) then begin
      LightMaterialSource1.Diffuse  := $FFFF0000 ;
      LightMaterialSource1.Emissive := $FFFF0000 ;
      for i := 0 to 10 do begin
         Cone1.Width := Cone1.Width + 1.0 ;
         Cone1.Depth := Cone1.Depth + 1.0 ;
         Application.ProcessMessages ;
      end;
   end;
end;

end.
